package org.vraptor.atx;

import org.objectweb.asm.AnnotationVisitor;
import org.objectweb.asm.Attribute;
import org.objectweb.asm.ClassVisitor;
import org.objectweb.asm.FieldVisitor;
import org.objectweb.asm.MethodVisitor;

/**
 * The type collector checks a type for an specific annotation.
 * 
 * @author Guilherme Silveira
 * @since 1.0
 */
public class TypeCollector implements ClassVisitor {

	private boolean componentAnnotationFound;

	public TypeCollector() {
	}

	public MethodVisitor visitMethod(int access, String name, String desc,
			String signature, String[] exceptions) {
		return null;
	}

	public void visit(int arg0, int arg1, String arg2, String arg3,
			String arg4, String[] arg5) {
	}

	public AnnotationVisitor visitAnnotation(String desc, boolean visible) {
		if(desc!=null && desc.equals("Lorg/vraptor/annotations/Component;")) {
			this.componentAnnotationFound = true;
		}
		return new AnnotationVisitor(){

			public void visit(String arg0, Object arg1) {	
			}

			public AnnotationVisitor visitAnnotation(String arg0, String arg1) {
				return this;
			}

			public AnnotationVisitor visitArray(String arg0) {
				return this;
			}

			public void visitEnd() {
			}

			public void visitEnum(String arg0, String arg1, String arg2) {
			}
			
		};
	}

	public void visitAttribute(Attribute arg0) {
	}

	public void visitEnd() {
	}

	public FieldVisitor visitField(int arg0, String arg1, String arg2,
			String arg3, Object arg4) {
		return null;
	}

	public void visitInnerClass(String arg0, String arg1, String arg2, int arg3) {
	}

	public void visitOuterClass(String arg0, String arg1, String arg2) {
	}

	public void visitSource(String arg0, String arg1) {
	}

	public boolean isComponentAnnotationFound() {
		return componentAnnotationFound;
	}

}
